package webladenMitRDBMS;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
import java.io.IOException;
import java.util.HashMap;
import java.util.Set;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.swing.JOptionPane;

/**
 *
 * @author dienert
 */
public class Controller extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        String url = "/WEB-INF/view/start.jsp";

        //ServletContext holen
        ServletContext sc = this.getServletContext();

        //absoluten pfad zu den xml-dateien mit hilfe des servlet-contexts ermitteln
        //String xmlVerzeichnis = sc.getRealPath("/WEB-INF/xml/");
        //JOptionPane.showMessageDialog(null, "abs. katalog-pfad: " + xmlVerzeichnis);

        // datenbankzugriffobjekt erzeugen
        //DbZugriff dbz = new DbZugriff();
        DBZugriff dbz = new DBZugriff("webladen");

        //session-objekt holen
        HttpSession session = request.getSession();
        HashMap<String, Position> warenkorb;
        warenkorb = (HashMap) session.getAttribute("warenkorb");

        try {
            //die liste aller hersteller ist konstant, wird aus db geholt und in session gelegt
            session.setAttribute("herstellerliste", dbz.getHerstellerListe());
        } catch (Exception ex) {
            Logger.getLogger(Controller.class.getName()).log(Level.SEVERE, null, ex);
        }

        //beim ersten aufruf gibt es noch kein warenkorb-objekt
        if (warenkorb == null) {
            warenkorb = new HashMap();
            session.setAttribute("warenkorb", warenkorb);
        }

        session.setAttribute("sichtbarkeit", "hidden");

        String action = request.getParameter("action");
        //beim ersten aufruf gibt es noch kein action-object:
        if (action == null) {
            action = "null";
        }

        if (action.equals("FILTER_HERSTELLER")) {
            String hersteller = request.getParameter("hersteller");
            //JOptionPane.showMessageDialog(null, hersteller);
            try {
                session.setAttribute("produktliste", dbz.getProduktListe(hersteller));
            } catch (Exception ex) {
                Logger.getLogger(Controller.class.getName()).log(Level.SEVERE, null, ex);
            }
            url = "/WEB-INF/view/ergebnis.jsp";
        } else if (action.equals("WARENKORB")) {
            String anzahlPar = request.getParameter("anzahl");
            int anzahl = 0;
            String artNr = request.getParameter("ARTNR");
            //JOptionPane.showMessageDialog(null, "anzahl: " + request.getParameter("anzahl"));
            try {
                anzahl = Integer.parseInt(anzahlPar);
            } catch (NumberFormatException nfe) {
                anzahl = 0;
            };

            try {
                warenkorb.put(artNr, new Position(dbz.getProdukt(artNr), anzahl));
            } catch (Exception ex) {
                Logger.getLogger(Controller.class.getName()).log(Level.SEVERE, null, ex);
            }

            //System.out.println("artNr: " + artNr+", anz.: " + anzahl);
            url = "/WEB-INF/view/warenkorb.jsp";
        } else if (action.equals("ENDE")) {
            url = "/WEB-INF/view/ende.jsp";
        } else if (action.equals("ADRESSE")) {
            url = "/WEB-INF/view/adresse.jsp";
        } else if (action.equals("KAUFEN")) {
            String nname = request.getParameter("nname");
            String vname = request.getParameter("vname");
            String adresse = request.getParameter("adresse");
            //dbz.erzeugeAuftrag(nname, vname, adresse, warenkorb);
            url = "/WEB-INF/view/danke.jsp";

            //ueber warenkorb iterieren und bestandeintraege aktualisieren
            Set<String> artNr = warenkorb.keySet();
            for (String item : artNr) {
                JOptionPane.showMessageDialog(null, item+": "+warenkorb.get(item).getAnzahl());
                //dbz.updateBestand(item, warenkorb.get(item).getAnzahl());
                //gesamten katalog neu speichern
                dbz.serializeProdukt();
            }
        }

        RequestDispatcher rd = sc.getRequestDispatcher(url);
        rd.forward(request, response);
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
